interupt_number 	equ	9
.model small
rom_bios_data	segment	at	40h
	org	1ah
	head	dw	?
	tail	dw	?
	buffer	dw	16	dup(?)
	buffer_end	label	word
rom_bios_data	ends
.code
org	100
first:	jmp	load_prog
	old_key_int	label	word
	old_keyboard_int	dd	?
prog	proc
	push	ax
	push	bx
	push	cx
	push	dx
	push	di
	push	si
	push	ds
	push	es
	pushf
	call	old_keyboard_int
	assume  ds:rom_bios_data
	mov	bx,rom_bios_data
	mov	ds,bx
;================================================
	mov	bx,tail
	cmp	bx,head
	je	exit
	sub	bx,2
	cmp	bx,offset buffer
	jae	no_wrop
	mov	bx,offset buffer_end
	sub	bx,2
no_wrop:mov	dx,[bx]	
	cmp	dx,8600h
	jne	exit
	mov	tail,bx
;--------------------------------
	mov	ax,40h
	mov	ds,ax
	cli
	mov	al,0adh
	out	64h,al
	sti
	cli
;
	mov	al,0edh
	out	60h,al
;
	cli
	mov	al,0aeh
	out	64h,al
	sti
	sti
;
	cli
	mov	al,0adh
	out	64h,al
	sti
	cli
;
	mov	al,0111b
	out	60h,al
;
	cli
	mov	al,0aeh
	out	64h,al
	sti
	sti	
;--------------------------------
exit:	pop	es
	pop	ds
	pop	si
	pop	di
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	iret
prog 	endp
;==================================================
load_prog	proc
	mov	ah,33h
	mov	al,interupt_number
	int	21h
	mov	old_key_int,bx
	mov	old_key_int[2],es
	mov	ah,25h
	lea	dx,prog
	int	21h
exit2:	mov	dx,offset load_prog
	int	27h
load_prog	endp
	end	first