sending macro	por,val,lb1
	cli			;disable hapenning int
lb1:
	in	al,064h		;read keyboard register
	test	al,10b		
	jnz	lb1		;if buffer is full reapeat again

	mov	al,val		;else 
	out	por,al		;send data to port
	sti			;disable hapenning int
endm
;****************************************************************************
codeseg	segment	para
	assume	cs:codeseg
	org	100h
begin:	jmp	b10init		;jum to initialization
saveint9	dd	?	;int	09h	address
duration	dw	100h
num		db	0
a10test:
	push	ax
	push	cx		;save registers
	in	al,60h		;get keystroke from port
	cmp	al,01h		;check esc key
	jne	jmp1

	sending	64h,0adh,lab1	;disable keyboard

	sending	60h,0edh,lab2	;microprossesor set led command

	sending	64h,0aeh,enlab1	;enable keyboard

	sending	64h,0adh,lab4	;disable keyboard

	sending	60h,num,lab5	;send parameter to microprossesor for on or off led

	sending	64h,0aeh,enlab2	;enable keyboard

	cmp	num,00000000b
	jne	nex1
	mov	num,00000001b
	jmp	jmp1
nex1:
	cmp	num,00000001b
	jne	nex2
	mov	num,00000011b
jmp1:	jmp	a50exit
nex2:
	cmp	num,00000011b
	jne	nex3
	mov	num,00000111b
	jmp	a50exit
nex3:
	mov	num,00000000b

a50exit:
	pop	cx		;restor registers
	pop	ax
	jmp	cs:saveint9	;resume int 09h

b10init:
	cli			;no int
	mov	ah,35h		;get address of int 09h
	mov	al,09h		;in es:bx
	int	21h
	mov	word	ptr	saveint9,bx	;and save it	
	mov	word	ptr	saveint9+2,es
	mov	ah,25h		;set new address for
	mov	al,09h		;int 09h in a10test
	mov	dx,offset a10test
	int	21h


	mov	ah,31h			;request stay resident
	mov	dx,offset b10init	;set size
	sti				;enable int
	int	21h


codeseg	ends
     end begin